Summary: Configuration Cache Manager
Name: ccm
Version: 2.2.8
Vendor: EDG / CERN
Release: 1
License: http://www.eu-datagrid.org/license.html
Group: quattor
Source: ccm-2.2.8.src.tgz
BuildArch: noarch
BuildRoot: /var/tmp/%{name}-build
Packager: Rafael A. Garcia Leiva @AUTHOR@ Piotr Poznanski

Requires: perl-LC
Requires: perl-Crypt-SSLeay
Obsoletes: edg-ccm

%description
Configuration Cache Manager


%prep
%setup

%build
make

%install
rm -rf $RPM_BUILD_ROOT
make PREFIX=$RPM_BUILD_ROOT install

%files
%defattr(-,root,root)
/usr/sbin/ccm-initialise
/usr/sbin/ccm-fetch
/usr/sbin/ccm-purge
/usr/lib/perl/EDG/WP4/CCM/CCfg.pm
/usr/lib/perl/EDG/WP4/CCM/CacheManager.pm
/usr/lib/perl/EDG/WP4/CCM/Element.pm
/usr/lib/perl/EDG/WP4/CCM/Fetch.pm
/usr/lib/perl/EDG/WP4/CCM/Property.pm
/usr/lib/perl/EDG/WP4/CCM/Stream.pm
/usr/lib/perl/EDG/WP4/CCM/Configuration.pm
/usr/lib/perl/EDG/WP4/CCM/Path.pm
/usr/lib/perl/EDG/WP4/CCM/Resource.pm
/usr/lib/perl/EDG/WP4/CCM/SyncFile.pm
/usr/share/man/man3/EDG::WP4::CCM::CacheManager.3pm.gz
/usr/share/man/man3/EDG::WP4::CCM::Configuration.3pm.gz
/usr/share/man/man3/EDG::WP4::CCM::Element.3pm.gz
/usr/share/man/man3/EDG::WP4::CCM::Fetch.3pm.gz
/usr/share/man/man3/EDG::WP4::CCM::Path.3pm.gz
/usr/share/man/man3/EDG::WP4::CCM::Property.3pm.gz
/usr/share/man/man3/EDG::WP4::CCM::Resource.3pm.gz
/usr/share/man/man3/EDG::WP4::CCM::CCfg.3pm.gz
/usr/share/man/man3/EDG::WP4::CCM::Stream.3pm.gz
/usr/share/man/man3/EDG::WP4::CCM::SyncFile.3pm.gz
/usr/share/man/man8/ccm-fetch.8.gz
/usr/share/man/man8/ccm-purge.8.gz
/usr/share/man/man8/ccm-initialise.8.gz
%dir /usr/share/doc/ccm-2.2.8/
%dir /usr/share/doc/ccm-2.2.8/eg/
/usr/share/doc/ccm-2.2.8/README
/usr/share/doc/ccm-2.2.8/MAINTAINER
/usr/share/doc/ccm-2.2.8/LICENSE
/usr/share/doc/ccm-2.2.8/ChangeLog
/usr/share/doc/ccm-2.2.8/eg/ccm.conf
/usr/share/doc/ccm-2.2.8/eg/nvapi-ex1
/usr/share/doc/ccm-2.2.8/eg/nvapi-ex2
/usr/share/doc/ccm-2.2.8/eg/nvapi-ex3
/usr/share/doc/ccm-2.2.8/eg/nvapi-ex4
/usr/share/doc/ccm-2.2.8/eg/nvapi-ex5
/usr/share/doc/ccm-2.2.8/eg/print_changes
/usr/share/doc/ccm-2.2.8/eg/print_prof
/etc/logrotate.d/*
/etc/cron.d/*
%config(noreplace) /etc/ccm.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
SOname=`uname`
if [ $SOname = "SunOS" ] ; then
    RESTART_CRON="no"
    #***   In Solaris, the /etc/cron.d directory is ignored.
    #*** The root crontabs must be in /var/spool/cron/crontabs/root
    CRONFILE=/var/spool/cron/crontabs/root
    #***   We take the crontab entries from the Linux ones
    FETCH_CRON=`grep ccm-fetch /etc/cron.d/ccm-fetch.cron`
    PURGE_CRON=`grep ccm-purge /etc/cron.d/ccm-purge.cron`
    #***   The Solaris crontab does not accept the "root" option
    FETCH_CRON=`echo "$FETCH_CRON" |sed s/'root '//g`
    PURGE_CRON=`echo "$PURGE_CRON" |sed s/'root '//g`
    #*** In Solaris, ccm-fetch will not work unless we add /usr/local/lib
    # to LD_LIBRARY_PATH. The cron jobs don't use the system environment.
    FETCH_CRON=`echo "$FETCH_CRON" |sed s!'('!'(LD_LIBRARY_PATH=/usr/local/lib; export LD_LIBRARY_PATH; '!`
    #***   We check if the entries don't exist or are commented
    FETCH_ENTRY=`grep '^"$FETCH_CRON"' "$CRONFILE"`
    PURGE_ENTRY=`grep '^"$PURGE_CRON"' "$CRONFILE"`
    if [ -z "$FETCH_ENTRY" ] ; then
	echo "$FETCH_CRON" >> "$CRONFILE"
        RESTART_CRON="yes"
    fi
    if [ -z "$PURGE_ENTRY" ] ; then
	echo "$PURGE_CRON" >> "$CRONFILE"
        RESTART_CRON="yes"
    fi
    #*** We must restart the daemon to tell cron to read again the new config
    if [ "$RESTART_CRON" = "yes" ] ; then
	/etc/init.d/cron stop > /dev/null 2>&1
	/etc/init.d/cron start > /dev/null 2>&1
    fi
elif [ "$SOname" = "Linux" ]; then
    if pgrep ncm-cdispd; then
	echo "New version of CCM installed. Reloading ncm-cdispd"
	killall -HUP ncm-cdispd
    fi
fi	

%preun
SOname=`uname`
if [ $SOname = "SunOS" ] ; then
    #*** Delete the ccm-fetch and ccm-purge cron entries
    CRONFILE=/var/spool/cron/crontabs/root
    CONTENTS=`cat "$CRONFILE" |grep -v ccm-fetch| grep -v ccm-purge`
    rm -f "$CRONFILE"
    echo "$CONTENTS" > "$CRONFILE"
    /etc/init.d/cron stop > /dev/null 2>&1
    /etc/init.d/cron start > /dev/null 2>&1
fi

%changelog
* Wed Sep 02 2009 Luis Fernando Muñoz Mejías

- Relax the dependencies, as per bug #55179.

* Wed Mar 04 2009 Luis Fernando Muñoz Mejías <Luis.Fernando.Munoz.Mejias@cern.ch>

- Convert REPORT and TABLE types to actual synonims of NLIST
instead of subtypes.

* Fri Dec 12 2008 Marco Emilio Poleggi,<Marco.Poleggi@cnaf.infn.it>

- [your comment here]

* Fri Dec 12 2008 Marco Emilio Poleggi,<Marco.Poleggi@cnaf.infn.it>

- [your comment here]

* Thu Nov 06 2008 "Luis Fernando"

- Fixing a warning related to the encoding of fetched information.

* Wed Nov 05 2008 "Luis Fernando"

- Whitespace and pretty printing changes.

* Wed Nov 05 2008 "Luis Fernando"

- Removing remaining methods referencing FETCH, LINK, STREAM and EMBED.

* Tue Nov 04 2008 "Luis Fernando"

- Reduced the "base_url" is not defined message to debug level.

During the workshop in Amsterdam we decided that this message caused
unneeded worries and fear to users. Debug is OK for this, as the module
works just fine without the base_url parameter.

* Fri Oct 31 2008 "Luis Fernando"

- Removed support for types fetch, embed, stream and link.

These types are no longer supported by the compiler, and thus during the
workshop it was agreed to drop them from CCM too.

* Fri Jul 18 2008 "Luis Fernando"

- Added new getUnescapedName and unescape.
Let's stop copying and pasting this everywhere!

* Mon Jul 14 2008 "Luis Fernando"

- Added an example /etc/ccm.conf to the RPM, and made it be installed as '.rpmnew' in case such file already exists.
Should solve the documented (but forgotten by users) "failed to create Fetch object" on AII servers.

* Mon Jul 07 2008 "Luis Fernando"

- Fixed the constructor of EDG::WP4::CCM::Configuration to get rid of taint warnings.

* Wed May 28 2008 root

- Encode some values to UTF-8

* Wed Mar 26 2008 Luis Fernando Muñoz Mejías

- Fixed the %post script trying to unconditionally kill ncm-cdispd, which
could break installations.

* Wed Mar 26 2008 Luis Fernando Muñoz Mejías

- Fixed bug #27529

* Tue Mar 11 2008 Luis Fernando Muñoz Mejías

- Fixed a bug that had the potential to disable the entire notification system.
Updated some tests.

* Mon Jan 14 2008 Rohitashva Sharma

- improved fetching of foreign profiles
- better singleton object for CacheManager

* Tue Nov 27 2007 Rohitashva Sharma

- Solved bug#21170 (won't fetch profile if /etc/noquattor is present

* Fri Nov 23 2007 Rohitashva Sharma

- Support for fetching foreign profiles 
fix for bug#21846

* Fri Jul 06 2007 German Cancio Melia

- Added failover URL to eg ccm.conf

* Fri Jun 15 2007 Charles Loomis

- fix bug #27230; treat undef values as an empty string

* Wed Apr 25 2007 Marco Emilio Poleggi,<Marco.Poleggi@cern.ch>

- ccm.conf: drop "profile_" prefix in XML filename

* Thu Mar 22 2007 Luis Fernando Muñoz Mejías

- Removed getRecHash, following Germán's indications.

* Wed Mar 21 2007 Luis Fernando Muñoz Mejías

- Added getTree method to Element class, as suggested in the workshop.

* Mon Feb 26 2007 Charles Loomis

- use utf8 encoding to extract values from database

* Mon Feb 26 2007 Charles Loomis

- use utf8 encoding for storing values in database

* Mon Feb 26 2007 Charles Loomis

- allow UTF8 encoding of machine profiles

* Wed Feb 07 2007 German Cancio Melia

- EDG::WP4::CCM::Element.pm: Added new getRecHash() function, Savannah #23574

* Fri Dec 01 2006 German Cancio Melia

- Reduce number of hourly ccm-fetch invocations from 3 to 1 and increase time smearing to 1h

* Sat Nov 25 2006 German Cancio Melia

- Now correctly handles the situation where force is defined but set to 0 in ccm-fetch - was causing to skip over if_modified_since() and thus downloading profile anyway

* Thu Nov 23 2006 German Cancio Melia

- Fixed ccm-purge dying whenever finding a stale CCM active profile lock, now reporting as [INFO] and cleaning up

* Thu Nov 23 2006 German Cancio Melia

- Fix Savannah #10558: Do skip over profile diff step when --force is set, in order to inconditionally update the CCM cache even if the new profile does not differ from the old one.

* Tue Nov 07 2006 German Cancio Melia

- More verbose debug logging; bugfix to not loop over 304 (no chaHTTP profile status

* Thu Nov 02 2006 German Cancio Melia

- Use standard Quattor-style timestamping when WARN/ERROR

* Fri Sep 15 2006 German Cancio Melia

- Add support for a failover profile, in case the URL in --profile is not available. Useful in case of expired SSL certificates or broken main servers which may prevent profile updates to happen

* Tue Sep 12 2006 German Cancio Melia

- Fix  #19416 - ccm-purge potentially removing active CCM profiles

* Tue Jun 20 2006 German Cancio Melia

- Fix bug #15857 (CCM not correctly releasing lock files when instantiating multiple configurations)

* Tue Sep 20 2005 German Cancio Melia

- Removed 'Provides' of edg-ccm as not liked (obsoletes/provides) by rpm 4.3.3

* Tue Sep 20 2005 German Cancio Melia

- Changed cron job permissions to 0644, Savannah #10791

* Thu Aug 18 2005 Juan Antonio LOPEZ PEREZ

- Corrected Solaris postinstall script
	   - In Solaris, ccm-fetch will not work unless we add /usr/local/lib
	   to LD_LIBRARY_PATH and the cron jobs don't use the system 
	   environment. In addition, the Solaris cron doesn't accept to set
	   environment variables for cron jobs except the PATH one. Then, I 
	   modified the crontab entry to add this directory to LD_LIBRARY_PATH
	   and to export it each time it runs the command. 
	   - I also modified it to restart the cron daemon at most once to
	   run the script faster.
	   - In addition, I made some other minor corrections to the scripts.

* Wed Aug 17 2005 German Cancio Melia

- Fix #9621 - ccm-fetch was clearing out profiles with attached processes

* Tue Aug 16 2005 German Cancio Melia

- Fix Savannah 10272: Always use lowercase for host, even if hostname() returns
	uppercase chars 

* Mon Aug 01 2005 Juan Antonio LOPEZ PEREZ

- Corrected the Solaris postinstall script. The Solaris crontab does not accept the "root" option.

* Thu Jul 21 2005 Juan Antonio LOPEZ PEREZ

- Made some changes for Solaris compatibility to 
	take into account the different Solaris cron system. 
	For that, I wrote a postinstall and a preunistall script
	to add the contrab entries of the ccm-fetch.cron and the
	ccm-purge.cron files to the Solaris root crontab file
	(/var/spool/cron/crontabs/root) and to remove them when
	the EDGccm package is uninstalled.

* Tue May 31 2005 German Cancio Melia

- Corrected warnings produced when values are set to '' in Debug and MD5 generation

* Tue May 31 2005 German Cancio Melia

- Added 'provides' for edg-ccm for backwards compatibility in specfile

* Tue May 31 2005 German Cancio Melia

- Added to 'general' ccm entries for cron and logrotate (ccm-fetch and ccm-purge)

* Wed May 25 2005 Marco Emilio Poleggi

- Added missing command line options for HTTPS

* Thu May 12 2005 Charles Loomis

- fix encoding for invalid xml tag names

* Wed May 11 2005 Charles Loomis

- add support for encoded xml tags

* Wed May 04 2005 Charles Loomis

- fix xmldb problems with fetch, link, and stream types

* Mon May 02 2005 German Cancio Melia

- Fixed getFetchValue and added getLinkValue in Property.pm ; move tmp files out of /tmp in Configuration.pm

* Mon Mar 21 2005 Marco Emilio Poleggi

- documentation update about HTTPS

* Wed Mar 02 2005 Rafael Garcia Leiva

- solved some warnings given by perl -w

* Fri Feb 04 2005 German CANCIO MELIA

- Fixed Savannah #6639 (Cal Loomis)

* Wed Feb 02 2005 German CANCIO MELIA

- (Cal Loomis): Added code code necessary to have have ccm-fetch accept alternate formats of the generated xml profiles (specifically the xmldb format). See Savannah #6576. Fixes as well Savannah #6532.

* Mon Jan 31 2005 German CANCIO MELIA

- Small fix in Makefile Savannah #6521

* Wed Jan 26 2005 German CANCIO MELIA

- Removed hardcoded /etc in CCfg.pm ; included EDG/WP4/CCM into 'configure' path

* Tue Dec 07 2004 German CANCIO MELIA

- Fix #5917 (Perl warning when ccm.conf not found)

* Fri Dec 03 2004 German CANCIO MELIA

- Added obsoletes tag for edg-ccm

* Fri Dec 03 2004 German CANCIO MELIA

- Fix Savannah #5873

* Thu Oct 28 2004 Rafael Garcia Leiva

- CCM quattorised

* Thu Oct 28 2004 German Cancio

- Solved Savannah #4472 - add /usr/lib/perl inconditionally, independently of EDG_LOCATION

1.3.1 (German Cancio)

Solved Savannah #4418:
    - remove modifications of EDG_LOCATION and friends in CCfg.pm

1.3.0 (Rafael Garcia Leiva)

Solved bug #3622:
    - allow CCM to use https, new options cert_file, key_file,
      ca_file and ca_dir
    - new option world_readable to control cache_root permissions
New example of configuration file:
    - match CCM and CDB profile names
    - example of new introduced options

1.2.6 (German Cancio)
  	 
Solved bug #3177: Restart profile counter when a max limit is reached

1.2.5 (Rafael Garcia Leiva)

Solved bug #3621: CCfg.pm calls non-existent Quit function

1.2.4 (German Cancio)

CCM is now noarch

1.2.3 (German Cancio)

Moved logrotate, cron fetch and purge to core CCM package

1.2.2 (German Cancio)

Added CERN-CC RPM 

1.2.1 (German Cancio)

Use now /var/lib/ccm instead of /var/run/ccm

1.2.0 (German Cancio)

Now uses LSB compliant paths.

1.1.9
- --profile-time & --context-time were being ignored: fixed.  Added
  retries for read timeouts.
- ccm fixed, it does not need root privilidges to run (with old
  cache schema).

1.1.7
- elementExists ($path) added to Configuration
- getValue ($path) added to Configuration

1.1.6
- exception bug fixed (_resolveEID was not handling exceptions correctly)

1.1.5
- listen daemon removed, comes in seperate package edg-cdp-listend
  as it is now extended to support new CDP
- portability fixes for Solaris (thanks to Carlos Ungil)
- configuration file extended with tags $host, $domain which get
  substitued to the hostname and domain name where CCM is running

1.1.0
- listen daemon added (edg-ccm-listend)
- Makefile and ccm.spec fixed
--- end of ChangeLog ---
